Index: /trunk/src/VBox/Installer/solaris/VBoxZoneAccess.c
===================================================================
--- /trunk/src/VBox/Installer/solaris/VBoxZoneAccess.c	(revision 49866)
+++ /trunk/src/VBox/Installer/solaris/VBoxZoneAccess.c	(revision 49867)
@@ -31,9 +31,10 @@
 *******************************************************************************/
 #define DEVICE_NAME     "/devices/pseudo/vboxdrv@0:vboxdrv"
-
+#define DEVICE_NAME_USR "/devices/pseudo/vboxdrv@0:vboxdrvu"
 
 int main(int argc, char *argv[])
 {
     int hDevice = -1;
+    int hDeviceUsr = -1;
 
     /* Check root permissions. */
@@ -57,9 +58,20 @@
     }
 
+    /* Open the user device. */
+    hDeviceUsr = open(DEVICE_NAME_USR, O_RDWR, 0);
+    if (hDeviceUsr < 0)
+    {
+        fprintf(stderr, "Failed to open '%s'. errno=%d\n", DEVICE_NAME_USR, errno);
+        close(hDevice);
+        return errno;
+    }
+
     /* Mark the file handle close on exec. */
-    if (fcntl(hDevice, F_SETFD, FD_CLOEXEC) != 0)
+    if (   fcntl(hDevice,    F_SETFD, FD_CLOEXEC) != 0
+        || fcntl(hDeviceUsr, F_SETFD, FD_CLOEXEC) != 0)
     {
         fprintf(stderr, "Failed to set close on exec. errno=%d\n", errno);
         close(hDevice);
+        close(hDeviceUsr);
         return errno;
     }
@@ -70,4 +82,5 @@
 
     close(hDevice);
+    close(hDeviceUsr);
 
     return 0;
Index: /trunk/src/VBox/Installer/solaris/vboxconfig.sh
===================================================================
--- /trunk/src/VBox/Installer/solaris/vboxconfig.sh	(revision 49866)
+++ /trunk/src/VBox/Installer/solaris/vboxconfig.sh	(revision 49867)
@@ -619,9 +619,8 @@
 
     ## Add vboxdrv to devlink.tab (KEEP TABS!)
-    # clean up devlink.tab (KEEP TABS!)
     if test -f "$PKG_INSTALL_ROOT/etc/devlink.tab"; then
         sed -e '/name=vboxdrv/d' -e '/name=vboxdrvu/d' "$PKG_INSTALL_ROOT/etc/devlink.tab" > "$PKG_INSTALL_ROOT/etc/devlink.vbox"
-        #echo "type=ddi_pseudo;name=vboxdrv;minor=vboxdrv	\D"  >> "$PKG_INSTALL_ROOT/etc/devlink.vbox"
-        #echo "type=ddi_pseudo;name=vboxdrv;minor=vboxdrvu	\M0" >> "$PKG_INSTALL_ROOT/etc/devlink.vbox"
+        echo "type=ddi_pseudo;name=vboxdrv;minor=vboxdrv	\D"  >> "$PKG_INSTALL_ROOT/etc/devlink.vbox"
+        echo "type=ddi_pseudo;name=vboxdrv;minor=vboxdrvu	\M0" >> "$PKG_INSTALL_ROOT/etc/devlink.vbox"
         mv -f "$PKG_INSTALL_ROOT/etc/devlink.vbox" "$PKG_INSTALL_ROOT/etc/devlink.tab"
     else
@@ -633,8 +632,8 @@
     if test "$REMOTEINST" -eq 0; then
         /usr/sbin/devfsadm -i "$MOD_VBOXDRV"
-        #if test $? -ne 0 || test ! -h "/dev/vboxdrv" || test ! -h "/dev/vboxdrvu" ; then
-        #    errorprint "Failed to create device link for $MOD_VBOXDRV."
-        #    exit 1
-        #fi
+        if test $? -ne 0 || test ! -h "/dev/vboxdrv" || test ! -h "/dev/vboxdrvu" ; then
+            errorprint "Failed to create device link for $MOD_VBOXDRV."
+            exit 1
+        fi
     fi
 
@@ -718,9 +717,9 @@
     fatal=$1
 
-    # Remove vboxdrv from devlink.tab
+    # Remove vboxdrv[u] from devlink.tab
     if test -f "$PKG_INSTALL_ROOT/etc/devlink.tab"; then
         devlinkfound=`cat "$PKG_INSTALL_ROOT/etc/devlink.tab" | grep vboxdrv`
         if test -n "$devlinkfound"; then
-            sed -e '/name=vboxdrv/d' "$PKG_INSTALL_ROOT/etc/devlink.tab" > "$PKG_INSTALL_ROOT/etc/devlink.vbox"
+            sed -e '/name=vboxdrv/d' -e '/name=vboxdrvu/d' "$PKG_INSTALL_ROOT/etc/devlink.tab" > "$PKG_INSTALL_ROOT/etc/devlink.vbox"
             mv -f "$PKG_INSTALL_ROOT/etc/devlink.vbox" "$PKG_INSTALL_ROOT/etc/devlink.tab"
         fi
